package com.sxtvs.open.api.clue.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.sxtvs.open.api.clue.dto.ClueDTO;
import com.sxtvs.open.api.clue.dto.VerifyDTO;
import com.sxtvs.open.api.clue.entity.Clue;
import com.sxtvs.open.api.clue.entity.Info;
import com.sxtvs.open.api.clue.entity.ClueReply;
import com.sxtvs.open.api.clue.service.impl.ClueReplyServiceImpl;
import com.sxtvs.open.api.clue.service.impl.ClueServiceImpl;
import com.sxtvs.open.core.auth.LoginRequired;
import com.sxtvs.open.core.sls.AliyunLogger;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-03-20
 */
@RestController
@RequestMapping("/clue")
public class ClueController {

    @Resource
    private ClueServiceImpl clueService;

    @Resource
    private ClueReplyServiceImpl clueReplyService;

    @RequestMapping("list")
    @LoginRequired
    public IPage<Clue> ls(@RequestBody ClueDTO clueDTO){
        return clueService.cluePage(clueDTO);
    }

    @RequestMapping("store")
    @LoginRequired
    public void store(@RequestBody Clue clue){
        clueService.store(clue);
    }

    @RequestMapping("verify")
    @LoginRequired
    public void verify(@Validated @RequestBody VerifyDTO verifyDTO){
        clueService.verify(verifyDTO);
    }

    @RequestMapping("reply")
    @LoginRequired
    public void reply(@RequestBody ClueReply clueReply){
        clueService.reply(clueReply);
    }

    @GetMapping("delete")
    @LoginRequired
    public void delete(@RequestParam("id") Long clueId){
        clueService.delete(clueId);
    }

    @GetMapping("info")
    @LoginRequired
    public Info info(@RequestParam("id") String clueId){
        return clueService.info(clueId);
    }

}
