package com.sxtvs.open.api.clue.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 
 * </p>
 *
 * @author syj
 * @since 2023-03-20
 */
@Getter
@Setter
public class Clue implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 线索id
     */
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private String id;

    private Long siteId;

    private Long catalogId;

    private String catalogInnerCode;

    private String branchInnerCode;

    /**
     * 线索归属：1-都市快报，2-第一热点新闻
     */
    private Integer ascription;

    /**
     * 线索标题
     */
    private String title;

    /**
     * 线索描述
     */
    private String summary;

    /**
     * 线索内容
     */
    private String content;

    /**
     * 工单时间
     */
    private LocalDateTime originTime;

    /**
     * 推送时间
     */
    private LocalDateTime addTime;

    /**
     * 0:待审核 1:审核通过  -1:审核未通过 
     */
    private Integer status;

    /**
     * 线索来源：1-热线电话，2-微信公众号
     */
    private Integer source;

    /**
     * 是否回复
     */
    private Integer replyFlag;

    /**
     * 回复时间
     */
    private LocalDateTime replyTime;

    private String userId;

    /**
     * 线索提供人
     */
    private String author;

    private String phone;

    private String address;

    /**
     * 爆料人姓名
     */
    private String nickname;

    private String email;

    private String videoId;

    /**
     * 播放地址
     */
    private String video;

    private String videoType;

    private String audio;

    /**
     * 图片
     */
    private String image;

    private String topFlag;

    private String type;

    private LocalDateTime topDate;

    private String commentFlag;

    private Long orderFlag;

    private String keyword;

    private String tag;

    private Long hitCount;

    private LocalDateTime publishDate;

    private String logo;

    private String modifyUser;

    private LocalDateTime modifyTime;

    private String isCheck;

    /**
     * cutv爆料标题
     */
    private String rcontent;

    /**
     * 1:上地图 0或者其他下地图
     */
    private String isUpMap;

    /**
     * 虚拟点击量
     */
    private Long virtualHitCount;

    /**
     * 虚拟点击量基数
     */
    private Long cardinalNumber;

    /**
     * 经度
     */
    private BigDecimal longitude;

    /**
     * 纬度
     */
    private BigDecimal latitude;

    private LocalDateTime createTime;

    /**
     * 0无效，1有效
     */
    private Byte validity;

    @TableField(exist = false)
    private Integer clueInfoCount;

    @TableField(exist = false)
    private String clueInfoType;
}
