package com.sxtvs.open.api.h5template.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sxtvs.open.api.h5template.dto.H5OperateParseDTO;
import com.sxtvs.open.api.h5template.dto.PageRequestDTO;
import com.sxtvs.open.api.h5template.entity.H5Operate;
import com.sxtvs.open.api.h5template.entity.H5Template;
import com.sxtvs.open.api.h5template.service.impl.H5OperateServiceImpl;
import com.sxtvs.open.api.h5template.service.impl.H5TemplateServiceImpl;
import com.sxtvs.open.api.h5template.service.impl.OSSService;
import com.sxtvs.open.core.auth.LoginRequired;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-03-30
 */
@RestController
@RequestMapping("/h5operate")
public class H5OperateController {
    @Resource
    private H5OperateServiceImpl h5OperateService;

    @PostMapping("store")
    @LoginRequired
    public void store(@RequestBody H5Operate h5Operate){
        h5OperateService.store(h5Operate);
    }

    @RequestMapping("list")
    @LoginRequired
    public Page<H5OperateParseDTO> ls(@RequestBody PageRequestDTO requestDTO){
//        return h5OperateService.list().stream().map(H5OperateParseDTO::new).collect(Collectors.toList());
        return h5OperateService.page(requestDTO);
    }

    @RequestMapping("update")
    @LoginRequired
    public void update(@RequestBody H5Operate h5Operate){
        h5OperateService.update(h5Operate);
    }

    @GetMapping("delete")
    @LoginRequired
    public void delete(@RequestParam("operateId") String operateId){
        h5OperateService.removeById(operateId);
    }

}
