package com.sxtvs.open.api.h5template.dto;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.sxtvs.open.api.h5template.entity.H5Operate;
import com.sxtvs.open.core.advice.BizException;
import lombok.Data;
import org.apache.http.util.TextUtils;
import org.springframework.beans.BeanUtils;

import java.time.LocalDateTime;
import java.util.ArrayList;

@Data
public class H5OperateParseDTO {
    private String operateId;

    private String title;

    private String h5Desc;

    private Object hoversList;

    private Integer h5Status;

    private LocalDateTime createTime;

    private LocalDateTime updateTime;

    private String url;

    private String templateId;

    private String cover;

    private String type;

    public H5OperateParseDTO(H5Operate h5Operate) {

        BeanUtils.copyProperties(h5Operate, this);
        ObjectMapper objectMapper = new ObjectMapper();
        try {
            if(!TextUtils.isEmpty(h5Operate.getHoversList())){
                this.hoversList = objectMapper.readValue(h5Operate.getHoversList(), Object.class);
            }else{
                this.hoversList = new ArrayList<>();
            }
        } catch (JsonProcessingException e) {
            throw new BizException("json转换失败");
        }

    }
}
