package com.sxtvs.open.api.h5template.service.impl;


import cn.hutool.core.date.DateTime;
import cn.hutool.core.io.IoUtil;
import cn.hutool.core.io.file.FileNameUtil;
import cn.hutool.http.HttpUtil;
import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import lombok.SneakyThrows;
import org.apache.http.util.TextUtils;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URL;
import java.util.UUID;


@Service
public class OSSService {
    private final OSS ossClient = new OSSClientBuilder().build("https://oss-cn-chengdu.aliyuncs.com",
            "LTAI4GEBqfF1GX4VwsYU2Wpg",
            "rVIv0E1lRfXOCrAmkFTZnfgWiuv4ea");

    private final String bucket = "smcic-index";

    private int index = 0;

    @SneakyThrows
    public String commonPut(MultipartFile file) {
        String dir = "operate/h5Template/img";
        String extName = FileNameUtil.extName(file.getOriginalFilename());

        ByteArrayInputStream inputStream = new ByteArrayInputStream(IoUtil.readBytes(file.getInputStream()));
        String date = new DateTime().toString("yyyyMMddHHmmss");
        String fileUrl = dir+"/" + UUID.randomUUID().toString().replace("-", "") + date + "." + extName;
        ossClient.putObject(bucket, fileUrl , inputStream);
        inputStream.reset();

        return "https://cxzx.smcic.net/" + fileUrl;
    }

    @SneakyThrows
    public String urlPut(String url, String extName) {
        HttpURLConnection connection = (HttpURLConnection) new URL(url).openConnection();
        InputStream inputStream = connection.getInputStream();
        String dir = "operate/clue/img";
        String date = new DateTime().toString("yyyyMMddHHmmss");
        String fileUrl = dir+"/" + UUID.randomUUID().toString().replace("-", "") + date + "." + extName;
        ossClient.putObject(bucket, fileUrl , inputStream);
        return "https://cxzx.smcic.net/" + fileUrl;
    }


}


