package com.sxtvs.open.api.news.entity;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.Data;

import java.util.HashMap;
import java.util.Map;

@Data
public class YoumeiEsData{

    private Long offset;

    private String objType;

    private String contentId;

    private String title;

    private String publishTime;

    private String content;

    private String sourceWebsite;

    private String sourceUrl;

    private String author;

    private String category;

    private String summary;

    private String city;

    public YoumeiEsData() {

    }

    public static YoumeiEsData of(CategoryData youmeiData){
        YoumeiEsData data = new YoumeiEsData();
        data.setTitle(youmeiData.getTitle());
        data.setAuthor(youmeiData.getAuthor());
        data.setContent(youmeiData.getContent());
        data.setContentId(youmeiData.getContentId());
        data.setObjType(youmeiData.getObjType());
        data.setOffset(youmeiData.getOffset());
        data.setPublishTime(youmeiData.getPublishTime());
        data.setSourceUrl(youmeiData.getSourceUrl());
        data.setSourceWebsite(youmeiData.getSourceWebsite());
        Map<String, Object> mp = getMapFromRaw(youmeiData.getRawData());
        data.setSummary(((String) mp.get("summary")).replaceAll("<img[^>]*/>", " ").replaceAll("<img[^>]*></img>", " ").replaceAll("<img[^>]*>", " "));
        data.setCity((String) ((Map<String, Object>) mp.get("contentExt")).get("contentProvince"));
        data.setCategory(youmeiData.getCategory());
        return data;
    }

    private static Map<String, Object> getMapFromRaw(String rawData) {
        Map<String, Object> map = new HashMap<>();
        try {
            ObjectMapper objectMapper = new ObjectMapper();
            map = objectMapper.readValue(rawData, new TypeReference<>() {});
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        return (Map<String, Object>) map.get("data");
    }

}
