package com.sxtvs.open.api.odata.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.sxtvs.open.api.odata.dto.Agg;
import com.sxtvs.open.api.odata.dto.NewMedia;
import com.sxtvs.open.api.odata.dto.RequestDTO;
import com.sxtvs.open.api.odata.service.impl.OpenDataServiceImpl;
import jakarta.annotation.Resource;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.apache.http.util.TextUtils;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("new-media")
public class NewMediaController {

    @Resource
    private OpenDataServiceImpl openDataService;

    @RequestMapping("agg")
    public IPage<Agg> aggList(@RequestBody RequestDTO requestDTO){
        return openDataService.aggPage(requestDTO);
    }

    @RequestMapping("list")
    public IPage<NewMedia> newMediaList(@RequestBody RequestDTO requestDTO){
        return openDataService.newMediaPage(requestDTO);
    }

    @RequestMapping("platform")
    public  List<Map<String, Object>>  platform(@RequestParam(value = "kh", defaultValue = "0") String kh){
//        return new String[]{"微博", "微信", "头条", "抖音", "快手", "B站"};
        return openDataService.platform(kh);
    }

    @RequestMapping("export")
    @ResponseBody
    public void export(HttpServletResponse response, HttpServletRequest request){
        String end = request.getParameter("end");
        String start = request.getParameter("start");
        String sort = request.getParameter("sort");
        if(TextUtils.isEmpty(sort)){
            sort = "";
        }
        openDataService.export(start, end, sort, response);
    }
}
