package com.sxtvs.open.api.user.controller;

import com.sxtvs.open.api.user.dto.RoleDTO;
import com.sxtvs.open.api.user.entity.UserRole;
import com.sxtvs.open.api.user.service.impl.UserRoleServiceImpl;
import com.sxtvs.open.core.auth.LoginRequired;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-05-26
 */
@RestController
@RequestMapping("/user/role")
public class UserRoleController {

    @Resource
    private UserRoleServiceImpl userRoleService;

    @RequestMapping("list")
    @LoginRequired
    public List<UserRole> userRoles(){
        return userRoleService.roles();
    }

    @RequestMapping("store")
    @LoginRequired
    public void store(@RequestBody RoleDTO roleDTO){
        userRoleService.createRole(roleDTO);
    }

    @RequestMapping("update")
    @LoginRequired
    public void update(@RequestBody RoleDTO roleDTO){
        userRoleService.updateRole(roleDTO);
    }

    @GetMapping("delete")
    @LoginRequired
    public void del(@RequestParam("id") Integer id){
        userRoleService.deleteRole(id);
    }
}
